#ifndef __MAIN_HEADER_FILE
#define __MAIN_HEADER_FILE

#define SMS_CLASS_NAME						"SMS"
#define SMS_MUTEX_NAME						"SMS Mutex"
#define SMS_INSTANCE_LOAD_NAME				"SMS Instance Load"

#define FREQ_50HZ							50
#define FREQ_60HZ							60

#define PLAYER_1							0
#define PLAYER_2							1
#define MAX_PLAYERS							2

#define SCREENSHOT_KEY						DIK_F12

typedef struct BMP
{
	BITMAPINFOHEADER						BitmapInfoHeader;
	RGBQUAD									Palette[256];
} BMP;

int WINAPI									WinMain(HINSTANCE, HINSTANCE, PSTR, int);
LRESULT CALLBACK							MainWindowProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK							ConfigureControlsProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK							ConfigureControlsKeyProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK							ConfigureFoldersProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK							AboutProc(HWND, UINT, WPARAM, LPARAM);
void										InitVRAM(void);
void										UpdatePalette(void);
void										OpenROM(char *);
void										AdjustWindowSize(void);
void										LoadSRAM(char *);
void										SaveSRAM(char *);
void										SetScreenScale(unsigned int);
void										SetUpdateFrequency(unsigned int);
void										SetFrameSkip(unsigned int);
int											ConfigureButton(HWND, int, int, char *);
BOOL										CreateSingleInstance(char *);
void										DestroySingleInstance(void);
BOOL										IsWindowsNT4(void);
void										PopulateConfigureControls(HWND);
void										PopulateJoystickCombo(HWND, int);
char										*GetSRAMName(void);
char										*GetBitmapInfoHeader(void);
char										*GetBitmapData(void);

#endif